;===============================================================================
;
;	PS/2L[{[hvgRRo[WA_v^(PPCA)
;
;		Author		: K.Takahashi(tokoya)
;		Version		: 1.00
;		Last Update	: 2000/11/17
;		Target		: AT90S2313
;		Comment		: ONbN8MHzgp
;
;	2000/09/19	: 
;	2000/10/24	: gX[g[hǉ
;	2000/11/06	: L[{[hւ̃R}hM@\ǉ
;	2000/11/15	: ϊe[u̍\ύX
;	2000/11/16	: zXgL[{[hփR}hM@\ǉ
;	2000/11/17	: ggX[g[hǉ
;
;===============================================================================

.include "2313def.inc"
.include "CodeTbl.inc"

.def	tx_cmd		= r12				; L[{[hւ̑MR}h
.def	tx_opt		= r13				; L[{[hւ̑MIvV
.def	rx_code		= r14				; L[{[h̎MR[h
.def	tx_code		= r15				; L[{[hւ̑MR[h

.def	tp_main		= r16				; C[N
.def	tp_int		= r17				; 荞ݓgp[N
.def	tp_send		= r18				; zXgւ̑MLN^
.def	i0_code		= r19
.def	i0_count	= r20
.def	pt_count	= r21				; peBJEg
.def	tx_count	= r22
.def	fg_mode		= r23				; S - SCANCODE
							; T - TRANSLATE
							; X - EXTEND TRANSLATE
.def	fg_key		= r24				; bit0 - key_up
							; bit1 - key_shift
							; bit2 - edge_flag
							; bit3 - e0_flag
							; bit4 - e1_flag
.def	fg_txrx		= r25				; bit0 - tx_request
							; bit1 - tx_option
							; bit2 - rx_busy
							; bit3 - rx_wait
.def	key_stat	= r26				; bit0 - left_ctrl
							; bit1 - left_shift
							; bit2 - left_alt
							; bit3 - right_ctrl
							; bit4 - right_shift
							; bit5 - right_alt
.def	led_stat	= r27				; bit0 - Scroll Lock
							; bit1 - Num Lock
							; bir2 = Caps Lock
.def	fg_cmd		= r28				; bit0 - 1Byte Command
							; bit1 - 2Byte Command(First)
							; bit2 - 2Byte Command(Second)
							; bit3 - LED Set

.equ	ASCII_MODE	= 0

.equ	KEY_UP		= 0
.equ	KEY_SHIFT	= 1
.equ	EDGE_FLAG	= 2
.equ	E0_FLAG		= 3
.equ	E1_FLAG		= 4

.equ	TX_REQUEST	= 0
.equ	TX_OPTION	= 1
.equ	RXC_WAIT	= 2
.equ	RX_BUSY		= 3

.equ	L_CTRL		= 0
.equ	L_SHIFT		= 1
.equ	L_ALT		= 2
.equ	R_CTRL		= 3
.equ	R_SHIFT		= 4
.equ	R_ALT		= 5

.equ	KB_CLK		= 2
.equ	KB_DATA		= 4

.equ	SCROLL_LOCK	= 0
.equ	NUM_LOCK	= 1
.equ	CAPS_LOCK	= 2

.equ	X1BYTE_CMD	= 0
.equ	X2BYTE_CMD_F	= 1
.equ	X2BYTE_CMD_S	= 2
.equ	LED_SET		= 3

.equ	MAKE_L_CTRL	= 0x90
.equ	MAKE_L_SHIFT	= 0x91
.equ	MAKE_L_ALT	= 0x92
.equ	MAKE_R_CTRL	= 0x93
.equ	MAKE_R_SHIFT	= 0x94
.equ	MAKE_R_ALT	= 0x95
.equ	BREAK_L_CTRL	= 0x96
.equ	BREAK_L_SHIFT	= 0x97
.equ	BREAK_L_ALT	= 0x98
.equ	BREAK_R_CTRL	= 0x99
.equ	BREAK_R_SHIFT	= 0x9A
.equ	BREAK_R_ALT	= 0x9B

.CSEG
.ORG	$0
		rjmp	RESET
		rjmp	EXT_INT0			; L[{[h荞
		rjmp	EXT_INT1			; }EX荞
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	UART_RXC			; VAM荞
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY

DUMMY:
		reti

;---------------------------------------
;	
;---------------------------------------
RESET:
		ldi	tp_main,low(RAMEND)		; X^bN|C^ݒ
		out	SPL,tp_main
	
		ldi	tp_main,0b11111111		; |[gao͂ɐݒ(fobOp)
		out	DDRB,tp_main

		ldi	tp_main,0b01000011		; |[gcPD5`PD2͂ɐݒ
		out	DDRD,tp_main
		ldi	tp_main,0b00000000		; vAbv
		out	PORTD,tp_main

		ldi	tp_main,(1<<ISC01)		; Ŋ荞ݔ
		out	MCUCR,tp_main

		ldi	tp_main,0b10011000		; MAM荞݋
		out	UCR,tp_main
		ldi	tp_main,12			; NbN8MHzUBRRl(38400bps)
		out	UBRR,tp_main

		clr	i0_code				; [NWX^
		ldi	i0_count,11
		ldi	fg_mode,'T'			; gX[g[h
		clr	fg_key
		clr	fg_txrx
		clr	key_stat
		clr	led_stat
		clr	fg_cmd

		ldi	tp_main,(1<<INT0)		; INT0荞݋
		out	GIMSK,tp_main
		sei					; 荞݋

;---------------------------------------
;	C[v
;---------------------------------------
MAIN:
		cbr	fg_txrx,(1<<RXC_WAIT)		; MʒmtONA
		clr	rx_code
MAIN_RX_0:
		sbrc	fg_txrx,TX_REQUEST		; MvtOĂH
		rjmp	MAIN_RX_1
		sbrs	fg_txrx,RXC_WAIT		; MtOĂM
		rjmp	MAIN_RX_0
		rjmp	MAIN_RX_2
MAIN_RX_1:
		sbrc	fg_txrx,RX_BUSY			; MrȂ犮܂ő҂
		brne	MAIN_RX_0
		rjmp	MAIN_TX
MAIN_RX_2:
	;
	; zXgփL[R[hM
	;
		mov	tp_send,rx_code
		cpi	fg_mode,'T'			; gX[g[hH
		breq	MAIN_RX_3
		cpi	fg_mode,'X'			; ggX[g[hH
		breq	MAIN_RX_3
		rcall	SEND				; XLR[ĥ܂ܑo
		rjmp	MAIN
MAIN_RX_3:
		rcall	TRANSLATE			; R[hϊĂ瑗o
		rjmp	MAIN	

MAIN_TX:
	;
	; L[{[hփR}hM
	;
		mov	tx_code,tx_cmd
		rcall	SEND_TO_KB			; L[{[hɃR}hM
		rcall	RX_WAIT				; ACKM
		sbrs	fg_txrx,TX_OPTION
		rjmp	MAIN_TX_0
		mov	tx_code,tx_opt
		rcall	SEND_TO_KB			; L[{[hɃIvVM
		rcall	RX_WAIT				; ACKM
MAIN_TX_0:
		cbr	fg_txrx,(1<<TX_REQUEST)		; MvtONA
		cbr	fg_txrx,(1<<TX_OPTION)		; IvVMtONA
		rjmp	MAIN				

;---------------------------------------
;	M҂
;---------------------------------------
RX_WAIT:
		cbr	fg_txrx,(1<<RXC_WAIT)		; MʒmtONA
		clr	rx_code
RX_WAIT_0:
		sbrs	fg_txrx,RXC_WAIT		; MtOĂM
		rjmp	RX_WAIT_0
		ret

;---------------------------------------
;	M
;---------------------------------------
SEND:
		sbis	USR,UDRE			; MI܂ő҂
		rjmp	SEND
		out	UDR,tp_send
		ret

;---------------------------------------
;	16il̑M(fobOp)
;---------------------------------------
SEND_HEX:
		push	tp_send
		lsr	tp_send
		lsr	tp_send
		lsr	tp_send
		lsr	tp_send
		ori	tp_send,0x30
		cpi	tp_send,0x3A
		brlo	SEND_HEX_0
		ldi	tp_main,0x07
		add	tp_send,tp_main
SEND_HEX_0:
		sbis	USR,UDRE			; MI܂ő҂
		rjmp	SEND_HEX_0
		out	UDR,tp_send
		pop	tp_send
		andi	tp_send,0x0F
		ori	tp_send,0x30
		cpi	tp_send,0x3A
		brlo	SEND_HEX_1
		ldi	tp_main,0x07
		add	tp_send,tp_main
SEND_HEX_1:
		sbis	USR,UDRE			; MI܂ő҂
		rjmp	SEND_HEX_1
		out	UDR,tp_send
		ret	

;---------------------------------------
;	R[hϊ
;---------------------------------------
TRANSLATE:
		sbrc	fg_key,KEY_UP
		rjmp	TRANSLATE_B_0
	;
	; tR[h`FbN
	;
		cpi	tp_send,0xE0			; tR[hH
		brne	TRANSLATE_M_00
		sbr	fg_key,(1<<E0_FLAG)		; tR[hLtO𗧂Ă
		rjmp	TRANSLATE_EXIT
TRANSLATE_M_00:
		cpi	tp_send,0xE1			; tR[hH
		brne	TRANSLATE_M_0
		sbr	fg_key,(1<<E1_FLAG)		; tR[hLtO𗧂Ă
		rjmp	TRANSLATE_EXIT
TRANSLATE_M_0:
		cpi	tp_send,0xF0			; u[NR[hH
		brne	TRANSLATE_M_1
		sbr	fg_key,(1<<KEY_UP)
		rjmp	TRANSLATE_EXIT
	;
	; L[ꂽ̏
	;
TRANSLATE_M_1:
		cpi	tp_send,0x14			; CTRL
		brne	TRANSLATE_M_3
		sbrc	fg_key,E0_FLAG
		rjmp	TRANSLATE_M_2
		sbrc	fg_key,E1_FLAG			; E1͖̎
		rjmp	TRANSLATE_EXIT
		sbrc	key_stat,L_CTRL			; ɉĂH
		rjmp	TRANSLATE_EXIT
		sbr	key_stat,(1<<L_CTRL)
		ldi	tp_send,MAKE_L_CTRL
		rjmp	TRANSLATE_M_A
TRANSLATE_M_2:
		sbrc	key_stat,R_CTRL			; ɉĂH
		rjmp	TRANSLATE_EXIT
		sbr	key_stat,(1<<R_CTRL)
		ldi	tp_send,MAKE_R_CTRL
		rjmp	TRANSLATE_M_A
		
TRANSLATE_M_3:
		cpi	tp_send,0x11			; ALT
		brne	TRANSLATE_M_5
		sbrc	fg_key,E0_FLAG
		rjmp	TRANSLATE_M_4
		sbrc	key_stat,L_ALT			; ɉĂH
		rjmp	TRANSLATE_EXIT
		sbr	key_stat,(1<<L_ALT)
		ldi	tp_send,MAKE_L_ALT
		rjmp	TRANSLATE_M_A
TRANSLATE_M_4:
		sbrc	key_stat,R_ALT			; ɉĂH
		rjmp	TRANSLATE_EXIT
		sbr	key_stat,(1<<R_ALT)
		ldi	tp_send,MAKE_R_ALT
		rjmp	TRANSLATE_M_A
		
TRANSLATE_M_5:
		cpi	tp_send,0x12			; L-SHIFT
		brne	TRANSLATE_M_6
		sbrc	key_stat,L_SHIFT		; ɉĂH
		rjmp	TRANSLATE_EXIT
		sbr	key_stat,(1<<L_SHIFT)
		ldi	tp_send,MAKE_L_SHIFT
		rjmp	TRANSLATE_M_A
TRANSLATE_M_6:
		cpi	tp_send,0x59			; R-SHIFT
		brne	TRANSLATE_M_7
		sbrc	key_stat,R_SHIFT		; ɉĂH
		rjmp	TRANSLATE_EXIT
		sbr	key_stat,(1<<R_SHIFT)
		ldi	tp_send,MAKE_R_SHIFT
		rjmp	TRANSLATE_M_A

TRANSLATE_M_7:
	;
	; e[uĕϊ
	;
		ldi	ZH,high(transtbl)		; ϊe[u
		ldi	ZL,low(transtbl)
		add	ZL,tp_send
		clr	tp_send
		adc	ZH,tp_send
		clc
		rol	ZL
		rol	ZH
		mov	tp_main,key_stat
		andi	tp_main,(1<<L_SHIFT)+(1<<R_SHIFT)	; SHIFTĂH
		brne	TRANSLATE_M_8
		sbrs	fg_key,E0_FLAG			; tR[hLH
		rjmp	TRANSLATE_M_9
TRANSLATE_M_8:
		ori	ZL,0x01				; ʃoCgANZX
TRANSLATE_M_9:
		lpm
		mov	tp_send,r0
	;
	; Num Lock
	;
		cpi	tp_send,0xB0			; 10Keyl?
		brlo	TRANSLATE_M_A
		cpi	tp_send,0xBA
		brsh	TRANSLATE_M_A
		sbrs	led_stat,NUM_LOCK		; Num Lock?
		rjmp	TRANSLATE_M_90
		andi	tp_send,0x0F			; B0-B930-39()
		ori	tp_send,0x30
		rjmp	TRANSLATE_M_A
TRANSLATE_M_90:
		andi	tp_send,0x0F			; B0-B9A0-A9(J[\ړL[)
		ori	tp_send,0xA0
		cpi	tp_send,0xA5			; 10keyl'5'ɑ΂J[\ړL[͖
		brne	TRANSLATE_M_A
		ldi	tp_send,0x00	
TRANSLATE_M_A:
	;
	; L[
	;
	;	tR[hE1tNumLockPauseɒu
	;	CTRLĂ鎞ScrollLockPauseɒu
	;
		cpi	tp_send,0xD1			; Num Lock?
		brne	TRANSLATE_M_A0
		sbrc	fg_key,E1_FLAG
		ldi	tp_send,0xAA			; PausẽR[hɒu
		rjmp	TRANSLATE_M_A1
TRANSLATE_M_A0:
		cpi	tp_send,0xD0			; Scroll Lock?
		brne	TRANSLATE_M_A1
		mov	tp_main,key_stat
		andi	tp_main,(1<<L_CTRL)+(1<<R_CTRL)	; CTRLĂH
		breq	TRANSLATE_M_A1
		ldi	tp_send,0xAA			; PausẽR[hɒu
TRANSLATE_M_A1:
	;
	; Caps Lock
	;
		sbrs	led_stat,CAPS_LOCK		; Caps Lock?
		rjmp	TRANSLATE_M_A3
		cpi	tp_send,'A'			; p啶?
		brlo	TRANSLATE_M_A2
		cpi	tp_send,'Z'+1
		brsh	TRANSLATE_M_A2
		ori	tp_send,0x20			; pɕϊ
		rjmp	TRANSLATE_M_A3
TRANSLATE_M_A2:
		cpi	tp_send,'a'			; p?
		brlo	TRANSLATE_M_A3
		cpi	tp_send,'z'+1
		brsh	TRANSLATE_M_A3
		andi	tp_send,0xDF			; p啶ɕϊ
TRANSLATE_M_A3:
	;
	; zXgɑM
	;
		cpi	tp_send,0x00			; R[h0x00͑MȂ
		breq	TRANSLATE_M_B
		cpi	fg_mode,'X'			; ggX[g[hH
		breq	TRANSLATE_M_A4
		cpi	tp_send,0x80			; R[h0x80ȏ͑MȂ
		brsh	TRANSLATE_M_A5
TRANSLATE_M_A4:
		rcall	SEND
TRANSLATE_M_A5:
	;
	; Scroll Lock/Num Lock/Caps LockL[LEDON/OFFs
	;
		cpi	tp_send,0xD0
		brlo	TRANSLATE_M_B
		cpi	tp_send,0xD3
		brsh	TRANSLATE_M_B
		rcall	SET_LED				; LEDON/OFF
TRANSLATE_M_B:
		cbr	fg_key,(1<<E0_FLAG)
		cbr	fg_key,(1<<E1_FLAG)
		rjmp	TRANSLATE_EXIT

	;
	; L[ꂽ̏
	;
TRANSLATE_B_0:
		sbrs	fg_key,E1_FLAG			; Pause/Break
		rjmp	TRANSLATE_B_00
		cpi	tp_send,0x77
		brne	TRANSLATE_EXIT
		rjmp	TRANSLATE_B_B
TRANSLATE_B_00:
		cpi	tp_send,0x14			; CTRL
		brne	TRANSLATE_B_3
		sbrc	fg_key,E0_FLAG
		rjmp	TRANSLATE_B_2
		sbrc	fg_key,E1_FLAG			; E1͖̎
		rjmp	TRANSLATE_EXIT
		cbr	key_stat,(1<<L_CTRL)
		ldi	tp_send,BREAK_L_CTRL
		rjmp	TRANSLATE_B_A
TRANSLATE_B_2:
		cbr	key_stat,(1<<R_CTRL)
		ldi	tp_send,BREAK_R_CTRL
		rjmp	TRANSLATE_B_A
		
TRANSLATE_B_3:
		cpi	tp_send,0x11			; ALT
		brne	TRANSLATE_B_5
		sbrc	fg_key,E0_FLAG
		rjmp	TRANSLATE_B_4
		cbr	key_stat,(1<<L_ALT)
		ldi	tp_send,BREAK_L_ALT
		rjmp	TRANSLATE_B_A
TRANSLATE_B_4:
		cbr	key_stat,(1<<R_ALT)
		ldi	tp_send,BREAK_R_ALT
		rjmp	TRANSLATE_B_A
		
TRANSLATE_B_5:
		cpi	tp_send,0x12			; L-SHIFT
		brne	TRANSLATE_B_6
		cbr	key_stat,(1<<L_SHIFT)
		ldi	tp_send,BREAK_L_SHIFT
		rjmp	TRANSLATE_B_A
TRANSLATE_B_6:
		cpi	tp_send,0x59			; R-SHIFT
		brne	TRANSLATE_B_7
		cbr	key_stat,(1<<R_SHIFT)
		ldi	tp_send,BREAK_R_SHIFT
		rjmp	TRANSLATE_B_A

TRANSLATE_B_7:
		rjmp	TRANSLATE_B_B
		
TRANSLATE_B_A:
	;
	; zXgɑM
	;
		cpi	fg_mode,'X'			; ggX[g[hH
		breq	TRANSLATE_B_A1
		cpi	tp_send,0x80			; R[h0x80ȏ͑MȂ
		brsh	TRANSLATE_B_B
TRANSLATE_B_A1:
		rcall	SEND
TRANSLATE_B_B:
		cbr	fg_key,(1<<KEY_UP)
		cbr	fg_key,(1<<E0_FLAG)
		cbr	fg_key,(1<<E1_FLAG)
		rjmp	TRANSLATE_EXIT
	
TRANSLATE_EXIT:
		ret

;---------------------------------------
;	LEDON/OFF
;---------------------------------------
SET_LED:
		cpi	tp_send,0xD0			; Scroll Lock
		brne	SET_LED_0
		ldi	tp_main,(1<<SCROLL_LOCK)
		rjmp	SET_LED_2
SET_LED_0:
		cpi	tp_send,0xD1			; Num Lock
		brne	SET_LED_1
		ldi	tp_main,(1<<NUM_LOCK)
		rjmp	SET_LED_2
SET_LED_1:
		cpi	tp_send,0xD2			; Caps Lock
		brne	SET_LED_3
		ldi	tp_main,(1<<CAPS_LOCK)
SET_LED_2:
		eor	led_stat,tp_main
		sbr	fg_txrx,(1<<TX_REQUEST)
		sbr	fg_txrx,(1<<TX_OPTION)
		ldi	tp_main,0xED
		mov	tx_cmd,tp_main
		mov	tx_opt,led_stat
SET_LED_3:
		ret		

;---------------------------------------
;	L[{[hփR}hM
;---------------------------------------
SEND_TO_KB:
		cli					; 荞݋֎~

		cbi	PORTD,KB_CLK			; CLK|[go͂Lɐݒ
		cbi	PORTD,KB_DATA			; DATA|[go͂Lɐݒ
		sbi	DDRD,KB_CLK			; |[gcPD2(KB_CLK)o͂ɐݒ(Lo)

		ldi	tp_main,128			; 64Sec҂(0.125Secx4x128=64Sec)
SEND_TO_KB_0:
		nop
		dec	tp_main
		brne	SEND_TO_KB_0

		sbi	DDRD,KB_DATA			; |[gcPD4(KB_DATA)o͂ɐݒ(Lo)(X^[grbg)
		cbi	DDRD,KB_CLK			; |[gcPD2(KB_CLK)͂ɐݒ

		ldi	tx_count,8
		clr	pt_count
		rcall	CLK_HIGHLOW			; CLK̗҂

SEND_TO_KB_1:
		ror	tx_code				; 1rbgEVtg
		brcs	SEND_TO_KB_2
		sbi	DDRD,KB_DATA			; Lo
		rjmp	SEND_TO_KB_3
SEND_TO_KB_2:
		cbi	DDRD,KB_DATA			; Ho(vAbvHɂȂ)
		inc	pt_count			; peBJEg
SEND_TO_KB_3:
		rcall	CLK_HIGHLOW			; CLK̗҂
		dec	tx_count
		brne	SEND_TO_KB_1

		sbrc	pt_count,0			; H
		rjmp	SEND_TO_KB_4
		cbi	DDRD,KB_DATA			; Lo(peBrbg)
		rjmp	SEND_TO_KB_5
SEND_TO_KB_4:		
		sbi	DDRD,KB_DATA			; Ho(peBrbg)
SEND_TO_KB_5:						
		rcall	CLK_HIGHLOW			; CLK̗҂
		cbi	DDRD,KB_DATA			; Ho(Xgbvrbg)

		rcall	CLK_HIGHLOW			; CLK̗҂
		sbis	PIND,KB_DATA			; ACK?
		rjmp	SEND_TO_KB_6
		
		ldi	tp_main,0xFF
		mov	tx_code,tp_main			; ZbgR}h
		rjmp	SEND_TO_KB		

SEND_TO_KB_6:
		sbis	PIND,KB_CLK			; CAChԂɂȂ܂ő҂
		rjmp	SEND_TO_KB_6

		clr	i0_code				; [NWX^
		ldi	i0_count,11
		clr	fg_key

		sei
		ret

;---------------------------------------
;	CLK̗҂
;---------------------------------------
CLK_HIGHLOW:
		sbis	PIND,KB_CLK
		rjmp	CLK_HIGHLOW
CLK_HIGHLOW_0:
		sbic	PIND,KB_CLK
		rjmp	CLK_HIGHLOW_0
		ret

;---------------------------------------
;	L[{[h荞
;---------------------------------------
EXT_INT0:
		in	r0,SREG				; SREGWX^Ҕ
		push	r0
		push	tp_int

		sbr	fg_txrx,(1<<RX_BUSY)		; MtO𗧂Ă

		sbrc	fg_key,EDGE_FLAG		; オ̊荞݁H
		rjmp	EXT_INT0_1

		cpi	i0_count,11			; peBAX^[grbgAXgbvrbg͏
		brsh	EXT_INT0_0
		cpi	i0_count,3
		brlo	EXT_INT0_0
		lsr	i0_code
		sbic	PIND,PD4
		ori	i0_code,0x80

EXT_INT0_0:
		ldi	tp_int,(1<<ISC01)+(1<<ISC00)	; オł̊荞ݔɐݒ
		out	MCUCR,tp_int
		sbr	fg_key,(1<<EDGE_FLAG)		; tOZbg
		rjmp	EXT_INT0_EXIT

EXT_INT0_1:
		ldi	tp_int,(1<<ISC01)		; ł̊荞ݔɐݒ
		out	MCUCR,tp_int
		cbr	fg_key,(1<<EDGE_FLAG)		; tONA
		dec	i0_count			; SrbgMH
		brne	EXT_INT0_EXIT

		mov	rx_code,i0_code			; MR[h
		clr	i0_code
		ldi	i0_count,11
		sbr	fg_txrx,(1<<RXC_WAIT)		; MʒmtO𗧂Ă
		cbr	fg_txrx,(1<<RX_BUSY)		; MtONA

EXT_INT0_EXIT:	
		pop	tp_int
		pop	r0				; SREGWX^𕜋A
		out	SREG,r0
		reti					; 荞݂߂

;---------------------------------------
;	}EX荞
;---------------------------------------
EXT_INT1:
		in	r0,SREG				; SREGWX^Ҕ
		push	r0

		pop	r0				; SREGWX^𕜋A
		out	SREG,r0
		reti					; 荞݂߂

;---------------------------------------
;	VAM荞
;---------------------------------------
UART_RXC:
		in	r0,SREG				; SREGWX^Ҕ
		push	r0
		push	tp_int
		push	tp_main

		in	tp_int,UDR
		tst	fg_cmd
		breq	UART_RXC_SKIP_00
		rjmp	UART_RXC_CMD

UART_RXC_SKIP_00:
		cpi	tp_int,'V'			; o[W
		brne	UART_RXC_SKIP_0
		ldi	tp_send,'P'
		rcall	SEND
		ldi	tp_send,'P'
		rcall	SEND
		ldi	tp_send,'C'
		rcall	SEND
		ldi	tp_send,'A'
		rcall	SEND
		ldi	tp_send,' '
		rcall	SEND
		ldi	tp_send,'V'
		rcall	SEND
		ldi	tp_send,'1'
		rcall	SEND
		ldi	tp_send,'.'
		rcall	SEND
		ldi	tp_send,'0'
		rcall	SEND
		ldi	tp_send,'0'
		rcall	SEND
		rjmp	UART_RXC_EXIT
	
UART_RXC_SKIP_0:
		cpi	tp_int,'S'			; XLR[h[h
		brne	UART_RXC_SKIP_1
		ldi	fg_mode,'S'
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_1:
		cpi	tp_int,'T'			; gX[g[h
		brne	UART_RXC_SKIP_11
		ldi	fg_mode,'T'
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_11:
		cpi	tp_int,'X'			; ggX[g[h
		brne	UART_RXC_SKIP_2
		ldi	fg_mode,'X'
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_2:
		cpi	tp_int,'L'			; LEDԎ擾
		brne	UART_RXC_SKIP_21
		mov	tp_send,led_stat
		ori	tp_send,0x30
		rcall	SEND
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_21:
		cpi	tp_int,'K'			; L[Ԏ擾
		brne	UART_RXC_SKIP_3
		mov	tp_send,key_stat
		andi	tp_send,0x07
		ori	tp_send,0x30
		rcall	SEND
		mov	tp_send,key_stat
		lsr	tp_send
		lsr	tp_send
		lsr	tp_send
		andi	tp_send,0x07
		ori	tp_send,0x30
		rcall	SEND
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_3:
		cpi	tp_int,'R'			; L[{[hZbg
		brne	UART_RXC_SKIP_4
		sbr	fg_txrx,(1<<TX_REQUEST)
		ldi	tp_main,0xFF
		mov	tx_cmd,tp_main
		clr	key_stat			; L[ԃNA
		clr	led_stat			; LEDԃNA
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_4:
		cpi	tp_int,'E'			; LEDԐݒ
		brne	UART_RXC_SKIP_5
		sbr	fg_cmd,(1<<LED_SET)
		rjmp	UART_RXC_EXIT
		
UART_RXC_SKIP_5:
		cpi	tp_int,'1'			; 1ByteR}h
		brne	UART_RXC_SKIP_6
		sbr	fg_cmd,(1<<X1BYTE_CMD)
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_6:
		cpi	tp_int,'2'			; 2ByteR}h
		brne	UART_RXC_EXIT
		sbr	fg_cmd,(1<<X2BYTE_CMD_F)
		rjmp	UART_RXC_EXIT

UART_RXC_CMD:
		sbrs	fg_cmd,LED_SET
		rjmp	UART_RXC_CMD_0
		sbr	fg_txrx,(1<<TX_REQUEST)
		sbr	fg_txrx,(1<<TX_OPTION)
		ldi	tp_main,0xED
		mov	tx_cmd,tp_main
		andi	tp_int,0x07
		mov	tx_opt,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT
		
UART_RXC_CMD_0:
		sbrs	fg_cmd,X1BYTE_CMD
		rjmp	UART_RXC_CMD_1
		sbr	fg_txrx,(1<<TX_REQUEST)
		mov	tx_cmd,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT

UART_RXC_CMD_1:
		sbrs	fg_cmd,X2BYTE_CMD_S
		rjmp	UART_RXC_CMD_2
		sbr	fg_txrx,(1<<TX_REQUEST)
		sbr	fg_txrx,(1<<TX_OPTION)
		mov	tx_opt,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT

UART_RXC_CMD_2:
		sbrs	fg_cmd,X2BYTE_CMD_F
		rjmp	UART_RXC_EXIT
		mov	tx_cmd,tp_int
		sbr	fg_cmd,(1<<X2BYTE_CMD_S)
		rjmp	UART_RXC_EXIT

UART_RXC_EXIT:
		pop	tp_main
		pop	tp_int
		pop	r0				; SREGWX^𕜋A
		out	SREG,r0
		reti					; 荞݂߂
